﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace CCars
{
    static class Program
    {
        /// <summary>
        /// A program belépési pontja
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);

            // A térkép beolvasása
            Térkép térkép = Térkép.Beolvas("terkep.txt");

            /*
             * Adat feldolgozó osztályok példányosítása
             */
            AktuálisÚtKalkulátor aktuálisKalkulátor = new AktuálisÚtKalkulátor();
            TeljesÚtKalkulátor teljesKalkulátor = new TeljesÚtKalkulátor(térkép);
           
            Főablak ablak = new Főablak(aktuálisKalkulátor, teljesKalkulátor, térkép);

            List<ISzenzorAdatFeldolgozó> feldolgozók = new List<ISzenzorAdatFeldolgozó>();
            feldolgozók.Add(aktuálisKalkulátor);
            feldolgozók.Add(teljesKalkulátor);
            feldolgozók.Add(ablak.térképMegjelenítő);

            /*
             * Szenzoradatok beolvasása és az adatfeldolgozó osztályokkal való interakció
             */
            new SzenzorAdatBeolvasó("szenzor.txt", feldolgozók).Beolvas();

            /*
             * A feldolgozott adatmodelhez a felhasználói felület megjelenítése
             */
            Application.Run(ablak);
        }
    }
}
